/*____________________________________________________________________________
	
	Zinf - Zinf Is Not FreeA*p (The Free MP3 Player)
	Portions copyright (C) 1998-1999 EMusic.com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	
	$Id: errors.cpp,v 1.4 2003/09/16 17:34:53 kgk Exp $
____________________________________________________________________________*/

#include "config.h"
#include "i18n.h"

const char* ErrorString[] = {

    gettext_noop ("The operation was successful"), //              kError_NoErr            = 0,
    gettext_noop ("An unknown error occurred"), //                 kError_UnknownErr       = 1,
    gettext_noop ("An invalid parameter was used"), //             kError_InvalidParam     = 2,
    gettext_noop ("There was an error loading the library"), //    kError_LoadLibFailed    = 3,
    gettext_noop ("Could not find the function"), //               kError_FindFuncFailed   = 4,
    gettext_noop ("No files were found"), //              = 5,
    gettext_noop ("Unable to locate preferences"), //              kError_NoPrefs = 6,
    gettext_noop ("The buffer was too small to hold the data"), // kError_BufferTooSmall = 7,
    gettext_noop ("Memory allocation failed"), //                  kError_OutOfMemory = 8,
    gettext_noop ("Access to the file is denied"), //              kError_FileNoAccess = 9,
    gettext_noop ("The file already exists"), //                   kError_FileExists = 10,
    gettext_noop ("An invalid argument was used"), //              kError_FileInvalidArg = 11,
    gettext_noop ("The file was not found"), //                    kError_FileNotFound = 12,
    gettext_noop ("kError_FileNoHandles"), //        = 13,
    gettext_noop ("kError_NoMoreLibDirs"), //        = 14,
    gettext_noop ("A NULL value is invalid"), //                   kError_NullValueInvalid = 15,
    gettext_noop ("kError_InvalidError"), //         = 16,
    gettext_noop ("The plugin was not initialized"), //            kError_PluginNotInitialized = 17,
    gettext_noop ("kError_GotDefaultMethod"), //     = 18,
    gettext_noop ("Input was unsuccessful"), //                    kError_InputUnsuccessful = 19,
    gettext_noop ("Seeking is not supported"), //                  kError_FileSeekNotSupported = 20,
    gettext_noop ("Output was unsuccessful"), //                   kError_OutputUnsuccessful = 21,
    gettext_noop("Initialization failed"), //                     kError_InitFailed = 22,
    gettext_noop ("Initialization failed safely"), //              kError_InitFailedSafely = 23,
    gettext_noop ("No data is available"), //                      kError_NoDataAvail = 24,
    gettext_noop ("The seek operation failed"), //                 kError_SeekFailed = 25,
    gettext_noop ("The thread was not created"), //                kError_CreateThreadFailed = 26,
    gettext_noop ("kError_BufferingUp"), //          = 27,
    gettext_noop ("kError_Interrupt"), //            = 28,
    gettext_noop ("kError_EventPending"), //         = 29,
    gettext_noop ("Hey, you screwed up"), //                       kError_YouScrewedUp = 30,
    gettext_noop ("No preference value was found"), //             kError_NoPrefValue = 31,
    gettext_noop ("There was an error in the syntax"), //          kError_SyntaxError = 32,
    gettext_noop ("Reached the end of the stream"), //             kError_EndOfStream = 33,
    gettext_noop ("Failed to connect to host"), //                 kError_ConnectFailed = 34,
    gettext_noop ("Failed to create socket"), //                   kError_CantCreateSocket = 35,
    gettext_noop ("Unable to set socket options"), //              kError_CannotSetSocketOpts = 36,
    gettext_noop ("Cannot bind socket"), //                        kError_CannotBind = 37,
    gettext_noop ("The database item was not stored"), //          kError_DbaseItemNotStored = 38,
    gettext_noop ("There was an error parsing the file"), //       kError_ParseError = 39,
    gettext_noop ("Error, not found"), //                          kError_NotFound = 40,
    gettext_noop ("There are no more formats left to iterate"), // kError_NoMoreFormats = 41,
    gettext_noop ("The requested format is not supported"), //     kError_FormatNotSupported = 42,
    gettext_noop ("There are no more devices left to iterate"), // kError_NoMoreDevices = 43,
    gettext_noop ("The requested device was not found"), //        kError_DeviceNotFound = 44,
    gettext_noop ("The requested feature is not supported"), //    kError_FeatureNotSupported = 45,
    gettext_noop ("The operation was cancelled by the user"), //   kError_UserCancel = 46,
    gettext_noop ("Unable to load bitmap image"), //               kError_LoadBitmapFailed = 47,
    gettext_noop ("The requested protocol is not supported"), //   kError_ProtocolNotSupported = 48,
    gettext_noop ("The URL is invalid"), //                        kError_InvalidURL = 49,
    gettext_noop ("Unable to locate host"), //                     kError_CantFindHost = 50,
    gettext_noop ("An I/O error occurred"), //                     kError_IOError = 51,
    gettext_noop ("There was an unknown server error"), //         kError_UnknownServerError = 52,
    gettext_noop ("A bad HTTP request was made"), //               kError_BadHTTPRequest = 53,
    gettext_noop ("Access is not authorized"), //                  kError_AccessNotAuthorized = 54,
    gettext_noop ("Access is forbidden"), //                       kError_AccessForbidden = 55,  
    gettext_noop ("The requested range is not acceptable"), //     kError_RangeNotExceptable = 56,
    gettext_noop ("Could not write to the file"), //            = 57,
    gettext_noop ("Could not read from the file"), //             = 58,
    gettext_noop ("Invalid version"), //                           kError_InvalidVersion = 59,
    gettext_noop ("An update is already being performed"), //      kError_AlreadyUpdating = 60,
    gettext_noop ("Failed to delete file"), //                     kError_UnlinkFailed = 61,
    gettext_noop ("Failed to copy file"), //                       kError_CopyFailed = 62,
    gettext_noop ("No items were updated"), //                     kError_NoItemsUpdated = 63,
    gettext_noop ("The database is not working"), //               kError_DatabaseNotWorking = 64,
    gettext_noop ("Duplicate database item"), //                   kError_DuplicateItem = 65,
    gettext_noop ("The requested item was not found"), //          kError_ItemNotFound = 66,
    gettext_noop ("The requested file was not found"), //          kError_HTTPFileNotFound  = 67,
    gettext_noop ("Failed to initialize your CD-ROM"), //          kError_CDInitFailed = 68,
    gettext_noop ("Cannot play CD track"),             //          kError_InvalidTrack = 69,
    gettext_noop ("Download denied"), //                           kError_DownloadDenied = 70,
    gettext_noop ("No CD is in the CD-ROM drive"),     //          kError_NoDiscInDrive = 71,  

    "kError_LastError", //            = 9999
};


/* arch-tag: b018d198-e34d-4b9f-a416-ac700ff852e2
   (do not change this comment) */
